% % 1. 
% center1 = 10;
% center2 = -5;
% 
% r1 = 5;
% r2 = 20;
% 
% ax_x = linspace(-20,20,100);
% ax_y = linspace(-20,20,100);
% 
% [X,Y] = meshgrid(ax_x, ax_y);
% 
% points1 = (X - center1).^2 + (Y - center1).^2 ;
% in_circle1 = (points1 <= r1^2);
% circle1 = points1.*in_circle1;
% 
% points2 = (X - center2).^2 + (Y - center2).^2 ;
% in_circle2 = (points2 <= r2^2);
% circle2 = points2.*in_circle2;
% 
% img = in_circle1 | in_circle2; 
% 
% figure()
% imagesc(img)
% 
% % 2.
% cimg = ~img; 
% 
% dist_img = circle1./(r1^2) + circle2./(r2^2);
% dist_img(circle1 & circle2) = dist_img(circle1 & circle2)/2;
% 
% figure, imagesc(dist_img)

% 1.
center1 = -10;
center2 = -center1; 
dist = sqrt(2*(2*center1)^2); 
radius = dist/2 * 1.4; 
lims = [floor(center1-1.2*radius) ceil(center2+1.2*radius)]; 
[x,y] = meshgrid(lims(1):lims(2)); 
bw1 = sqrt((x-center1).^2 + (y-center1).^2) <= radius; 
bw2 = sqrt((x-center2).^2 + (y-center2).^2) <= radius; 
bw = bw1 | bw2; 
figure, imshow(bw,'InitialMagnification','fit'), title('bw') 

% 2.
D = bwdist(~bw); 
figure, imshow(D,[],'InitialMagnification','fit') 
title('Distance transform of ~bw') 

% 3.
D = -D;
D(~bw) = -Inf;

% 4.
L = watershed(D); 
rgb = label2rgb(L,'summer',[.5 .5 .5]); 
figure, imshow(rgb,'InitialMagnification','fit') 
title('Watershed transform of D')